﻿/*
	v1.1.3 - arreglo label firefox, calendars
	v1.1.2 - ZFDateDiff, ZFDateAge, calendar, focus,  pasaje zenscripts a zfcore.
	v1.1.1	- pathconvert fix
	v1.1.0	- save, pathconvert
	v1.0.0: 	- Arreglos en el manejo del xml de la respuesta, responseXML y responseText
		- Encabezados xml (xml bien formado)
		- arreglos en el xml de respuesta: <tag/> vs <tag></tag>
*/
var ZFCoreVersion	= 'v1.1.3';
var GXPARAMETERS 	= new Array();
var ZFFieldPrefix 	= 'zffieldid';

//ZFScripts.
//calendar
var months = new Array("Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Setiembre", "Octubre", "Noviembre", "Diciembre");
var daysInMonth = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
var days = new Array("D", "L", "M", "M", "J", "V", "S");
today = new ZFGetToday();	
var element_id;

//Aplican resetform
var zfValidaForm = false;
var aVal = new Array();
var aValOld = new Array();
var bDeb =0;


//	GX PROMPT FUNCTIONS
function ZFPromptGetLink(u,p,w,h){

	var aParms = p.split(',');
	var cField = '';
	var value  = '';
	var sParms = '';
	var oField = null;

	for(i = 0; i < aParms.length; i++){  //for each constants, formulas and/or controls
		//resolve control
		aParms[i] = trim(aParms[i]);
		if (aParms[i].substring(0,1) == "#") //control
		{
			cField	= ZFFieldPrefix + aParms[i].replace("#","");
			oField	= $(cField);
			GXPARAMETERS[i] = {Ctrl:oField, isKey:false};
		}
		//resolve GET parms
		value  = ZFGetFunction( '', aParms[i]);
		sParms = (sParms != '')? sParms + ',':'';
		sParms = sParms + escape(value); //$F(oField);
	}
	link = u + '?' + sParms + '|' +'toolbar=no,location=no,directories=no,status=yes,menubar=no,scrollbars=yes,resizable=yes,copyhistory=no';
	link = link + ',width=' + w + ',height=' + h;
	//alert(u +','+p + ',' + link);
	return link;
};

/*	SERVICE PROVIDER FUNCTIONS
	Service Provider template*/
function ZFSP(id,u,p,onS,onF){
	this.id			= id;
	this.url		= u;
	this.parms		= p;
	this.onsuccess	= onS;
	this.onfailure	= onF;
};
//Msg  object
function ZFSPMsg(vc,vv,ve,vt,vrc){
	this.code = vc;
	this.value= vv;
	this.extraInfo = ve;
	this.type = vt;
	this.respCode = vrc;
};

function ZFSPGetAjaxParms(p,type,actionId){
	/*receives a ZFParms like this: string,9, &TODAY, #number  
		and returns ->  p1: value1, p2: value2,...  
		Type: user (null or empty)  or standard 
		ActionId: ZFId of the element.(no se puede por limitacion del Editor)
	*/
	var parms = '';
	var value = '';

	switch(type) {
		case "zfconfirm":	//send ZFForm xml
			//parms = "<?xml version='1.0' encoding='UTF-8'?>" + GenerateXmlValues();
			parms = GenerateXmlValues();
			break;
		default:	//send xml for user action
			p = p.split(',');
			parms = '<ZFSPMessage>\n';
			parms = parms + '<Action>' + actionId + '</Action>\n';
			parms = parms + '<ZFSPParameters>\n';
			for (i = 0; i < p.length; i++) {
				p[i] = trim(p[i]);
				value = ZFGetFunction('',p[i]);
				parms = parms + '<ZFSPMessage.ParameterItem>\n';
				parms = parms + '<Code>' + 'p'+ (i + 1) + '</Code>\n';
				parms = parms + '<Value>' + escape(value) + '</Value>\n';
				parms = parms + '<ExtraInfo/>\n';
				parms = parms + '</ZFSPMessage.ParameterItem>\n';
/*get format parms 
	parms = (parms != '')? parms + ',':'';
	parms = parms + 'p' + i + '=' + escape(value);
*/
			}
			parms = parms + '</ZFSPParameters>\n';
			parms = parms + '</ZFSPMessage>\n';
	}
	return parms;
}

/*Function to call from the ZFForm*/
function ZFSPCall(obj){
	var ajaxParms 	=	'';
	var actionType	=	obj.readAttribute("zfsptype"); 
	var SP = new ZFSP(	obj.readAttribute("zfid"),
						obj.readAttribute("zfspurl"),
						obj.readAttribute("zfspparms"),
						obj.readAttribute("zfsponsuccess"),
						obj.readAttribute("zfsponfailure")
					 );
	if( SP.url != '')
	{
		ajaxParms = ZFSPGetAjaxParms(SP.parms, actionType, SP.id);
		//alert( 'u=' + SP.url + ',p=' + ajaxParms);
		//SP.url = '/proxy?url=' + encodeURIComponent(SP.url);
		var ZFAjax = new Ajax.Request(SP.url,
			{
				contentType:'text/xml',
				method:'post',
				encoding: 'UTF-8',
				//parameters: ajaxParms,
				postBody: ajaxParms,
				onSuccess: function(t){
								try{ eval(SP.onsuccess)(t);} catch(e)
								{
									//bug en IE, no retorna el responseXML, si el text.
									var txtDoc = t.responseText; 
									var xmlDoc = t.responseXML;
									//alert(t.responseText);
									if(!xmlDoc || xmlDoc.childNodes.length==0 || xmlDoc.childNodes.length==1){ 
										xmlDoc = ZFXMLDocFromString(txtDoc);
									}
									ZFSPXMLResponseRead(xmlDoc);
								}	
							},
				on404: function(t) {
						alert('Error 404: no se encontro la url "' + SP.url);
				},
				onFailure: function(t){
								 try{ eval(SP.onfailure)(t);} catch(e)
								{
									ZFSPAjaxError(t);
								}
							}
			}
		);
	}
	else
	{
		alert('No se especifico una URL para el Service Provider (en el elemento ' + obj.id + ')',status);
	}
}
function ZFSPAjaxError(t){
	text = "Se ha producido un error al obtener los datos. ";
	text = text + "\nError: " + t.status + ' - ' + t.statusText;
//		+ "\nheaders: " + t.getAllResponseHeaders();
	ZFAlert(text, false);
};



/*ZFExtra lib*/
function ltrim(s) { return s.replace(/^\s+/, "");};
function rtrim(s) { return s.replace(/\s+$/, "");};
function trim(s)  { return rtrim(ltrim(s));};
function ZFAlert(t,s){
	if(s == true){
		window.status = t;
		if(window.status != t) alert(t); //firefox off status
	} else {
		alert(t);
	}
};
function ZFFormClose(){
	//funciona con IE o con Firefox(solo en el caso que sea abierto con javascript)
	window.opener = this;
	window.close();
	return false;
}

function ZFSPXMLResponseRead(xmlDoc){
	//obtengo parms recibidos
	var msg = ZFSPXMLGetParam(xmlDoc,'OUT'); 
	var ZFMsg = null;
	var ok = false;
	//intenta accion de usuario
	try {
		ZFUserAfterAction(msg);
	} catch(e) {
		//si recibi algun msg
		if (msg.length > 0){ 
			var action = msg[0];
			msg = msg.slice(1);
			for ( var i = 0; i < msg.length; i++) {
				ZFMsg = msg[i];
				//alert( 'c=' + ZFMsg.code + ',v=' + ZFMsg.value + ',ei='+ ZFMsg.extraInfo+'t=' + ZFMsg.type + ',rc=' + ZFMsg.respCode);
				//muestra msgs (salvo los ignored)
				if (ZFMsg != null && ZFMsg.type != '0'){ 	//0= ignored, 1= w,2=error, 3= success
					if (ZFMsg.type == '3')ok= true;			//success
					ZFAlert(ZFMsg.value,false);
				}
			}
			//alert(action +','+ok);
			//accion por defecto:
			//- si es zfconfirm y recibe success = hace exit del form
			if (action.toLowerCase() == 'zfconfirm' && ok == true) ZFFormClose();
		}
	}
};

function ZFSPXMLGetParam(xmlDoc,type){
	var msg = [];
	var fc,fv,fei,ft,frc = '';
	if ( xmlDoc.childNodes.length > 0 ){
		//1er elem es el action(string), luego los msg recibidos (objetos ZFSPMsg)
		msg.push(xmlDoc.getElementsByTagName('Action')[0].childNodes[0].nodeValue);
		if (type == 'IN'){
			var xmlDocParms = xmlDoc.getElementsByTagName("ZFSPMessage.ParameterItem");
			for (var i = 0; i < xmlDocParms.length; i++){
				if(document.all){
					//try porque <tag/> da null el catch es el empty
					try{ fc	= xmlDocParms[i].childNodes[0].childNodes[0].nodeValue;} catch(e) {fc = '';}
					try{ fv	= xmlDocParms[i].childNodes[1].childNodes[0].nodeValue;} catch(e) {fv = '';}
					try{ fei= xmlDocParms[i].childNodes[2].childNodes[0].nodeValue;} catch(e) {fei = '';}
				} else {
					try{ fc	= xmlDocParms[i].childNodes[1].childNodes[0].nodeValue;} catch(e) {fc = '';}
					try{ fv	= xmlDocParms[i].childNodes[3].childNodes[0].nodeValue;} catch(e) {fv = '';}
					try{ fei= xmlDocParms[i].childNodes[5].childNodes[0].nodeValue;} catch(e) {fei = '';}
				}
				var ZFMsg = new ZFSPMsg(fc,fv,fei,'','');
				msg.push(ZFMsg); //add item
			}
		} else {
			var xmlDocParms = xmlDoc.getElementsByTagName('ZFSPMessage.CollectionOutItem');
			for (var i = 0; i < xmlDocParms.length; i++){
				if(document.all){
					try{ fc	= xmlDocParms[i].childNodes[0].childNodes[0].nodeValue;} catch(e) {fc = '';}
					try{ fv	= xmlDocParms[i].childNodes[1].childNodes[0].nodeValue;} catch(e) {fv = '';}
					try{ fei= xmlDocParms[i].childNodes[2].childNodes[0].nodeValue;} catch(e) {fei = '';}
					try{ ft	= xmlDocParms[i].childNodes[3].childNodes[0].nodeValue;} catch(e) {ft = '';}
					try{ frc= xmlDocParms[i].childNodes[4].childNodes[0].nodeValue;} catch(e) {frc = '';}
				} else {
					try{ fc	= xmlDocParms[i].childNodes[1].childNodes[0].nodeValue;} catch(e) {fc = '';}
					try{ fv	= xmlDocParms[i].childNodes[3].childNodes[0].nodeValue;} catch(e) {fv = '';}
					try{ fei= xmlDocParms[i].childNodes[5].childNodes[0].nodeValue;} catch(e) {fei = '';}
					try{ ft	= xmlDocParms[i].childNodes[7].childNodes[0].nodeValue;} catch(e) {ft = '';}
					try{ frc= xmlDocParms[i].childNodes[9].childNodes[0].nodeValue;} catch(e) {frc = '';}
				}
				var ZFMsg = new ZFSPMsg(fc,fv,fei,ft,frc);
				msg.push(ZFMsg); //add item
			}
		}
	}
	msg.compact();
	return msg;
};

function ZFXMLDocFromString(txt){
	var xmlDoc = null;
	try { //IE
		xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
		xmlDoc.async="false";
		xmlDoc.loadXML(txt);
	} catch(e) {
		try {//Firefox, Mozilla, Opera, etc.
			parser=new DOMParser();
			xmlDoc=parser.parseFromString(txt,"text/xml");
		}
		catch(e) {alert(e.message)}
	}
	return xmlDoc;
};


//fso
function ZFFSPGetCurrentDirectory() {
    path = unescape(document.location);
    path = path.substring(8,path.lastIndexOf("/")+1); //chop off "file:///" and file name
    return path;
}

function ZFFSOGetFileName (filePath) {
   var fileName = null;
   var ind=filePath.lastIndexOf("\\");
   if(ind!=-1){
	   fileName=filePath.substr(ind+1);
   }
   else{
	   fileName=filePath;
   }
   return fileName;
}
	
function ZFFSOPathConvertLocal(s){
	s = s.replace(/\\/g, '/');	
	s = encodeURI(s);
	return s;	
}

function ZFFSOSaveFile(filePath, content) {
   var status = null;
   try{
           /*if (navigator.userAgent.indexOf("Firefox")!=-1){
		//status = true;
		
	   }*/
		
	   if(Prototype.Browser.IE){
		   status = ZFFSOIESaveFile(filePath, content);
	   }
	   //else{
		   if(navigator.userAgent.indexOf("Firefox")!=-1){
			   
			   status = ZFFSOFFSaveFile(filePath, content);
				
		   }
	   //}
	} catch(e) {}
	
   return status;
}

function ZFFSOIESaveFile(fn, content) {

	//creo obj fso
	try{
	   var fso = new ActiveXObject("Scripting.FileSystemObject");
	}catch(e){  
	  return false; //cancela
	}
	
	try{ 
		if (fn == null || fn == '')
			fn = ZFFSPGetCurrentDirectory() +ZFFSOGetFileName(fn);			
        var file = fso.CreateTextFile(fn, true);
	} catch (e) {alert( "Grabando " + fn +".\nError:" + e.description); return false;}
	
	try{ 
		if(file){
           file.Write(content);
           file.close();
		}
	} catch(e) { file.Close(); alert( e.description); return false;}	
	return true;
}
	
function ZFFSOFFSaveFile(filePath, content){

netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

	try{
	    if (!filePath)
			
		file = this.FxChoiceFile();
	    else {
	   	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var filecopy = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var filepathcopy = filePath.replace(".htm","_copy.htm")

		file.initWithPath(filePath);
		filecopy.initWithPath(filepathcopy);
       	    }
	}
	catch(e){
		window.alert( 'Error ' + e.description);
	}

   if(window.Components){
	try
	   {
		
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var allow = 'PR_TRUE';
		if(filecopy.exists()){
		  
		  filecopy.remove(allow);
		}

		filecopy.create(0, 0664);
			
		var outcopy = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		outcopy.init(filecopy, 0x20 | 0x02, 00004,null);
        	var content2 = "<html>" + content + "</html>";
		outcopy.write(content2, content.length);
		outcopy.flush();
		outcopy.close();

		//var allow = 'PR_TRUE';
		if(file.exists()){
		  file.remove(allow);
		}

		file.create(0, 0664);
		
			
		var out = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		out.init(file, 0x20 | 0x02, 00004,null);

		content = ZFFSOFFReplaceValuesInContent(content);
        	content = "<html>" + content + "</html>";
		out.write(content, content.length);
		out.flush();
		out.close();

		var allow2 = 'PR_TRUE';
		filecopy.remove(allow2);
	 
	   return(true);
		}
   	 catch(e)
		{
	   alert("Exception while attempting to save\n\n" + e);
	   return(false);
	 }
   }
		
   return(null);
}

function ZFFSOFFReplaceValuesInContent(content){
	var inputs = document.getElementsByTagName("*");
	for(j=0;j<inputs.length;j++)
	{
	    var inputElement = inputs[j];
	    if(inputElement.id.indexOf("zffieldid") == 0)
	    {
            var lowerContent = content.toLowerCase();
	        var text = 'id="' + inputElement.id.toLowerCase() + '"';
	        if(inputElement.nodeName.toLowerCase() == "textarea")
	        {
	            var idIndex = lowerContent.indexOf(text);
	            var greaterIndex = lowerContent.indexOf('>', idIndex);
	            var lesserIndex = lowerContent.indexOf('<', greaterIndex + 1);
	            content = content.substring(0, greaterIndex + 1) + inputElement.value + content.substring(lesserIndex); 
	        }else if(inputElement.nodeName.toLowerCase() == "input"){
	            var idIndex = lowerContent.indexOf(text);
	            var valueIndex = lowerContent.indexOf('value="', idIndex);
	            var cuotIndex = lowerContent.indexOf('"', valueIndex + 7);
	            content = content.substring(0, valueIndex + 7) + inputElement.value + content.substring(cuotIndex); 
	        }else if(inputElement.nodeName.toLowerCase() == "select"){
	            var idIndex = lowerContent.indexOf(text);
	            var closeSelectIndex = lowerContent.indexOf('</select>', idIndex);
	            var valueIndex = lowerContent.indexOf('value="', idIndex);
	            var cuotIndex = lowerContent.indexOf('"', valueIndex + 7);
	            content = content.substring(0, valueIndex + 7) + inputElement.value + content.substring(cuotIndex); 
	            
	            var selectedIndex = lowerContent.indexOf('selected="selected"', valueIndex + 7);
	            if(selectedIndex > 0 && selectedIndex < closeSelectIndex)
	                content = content.substring(0, selectedIndex) + content.substring(selectedIndex + 19); 	
	                                
	            lowerContent = content.toLowerCase();
	            
	            var optionValueIndex = lowerContent.indexOf('value="' + inputElement.value.toLowerCase() + '"', valueIndex + 7);
	            var cuotIndex = lowerContent.indexOf('"', optionValueIndex + 7);
	            content = content.substring(0, optionValueIndex) + 'selected="selected" ' + content.substring(optionValueIndex); 
	            
	        }else {
	            throw "El tipo de tag '" + inputElement.nodeName + "' no esta siendo considerado al generar el htm";
	        }
	    }
	}
	return content;
}

function ZFFSOLoadFile (filePath){
   var content = null;
   if(Prototype.Browser.IE){
	   content = this.ZFFSOIELoadFile(filePath);
   }
   else{
	   if(Prototype.Browser.Gecko){
		   content = this.ZFFSOFFLoadFile(filePath);
	   }
   }
   return content;
}

function ZFFSOIELoadFile(filePath) {
	try
	{
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		var file = fso.OpenTextFile(filePath,1);
		var content = file.ReadAll();
		file.Close();
	}
	catch(e)
	{
	//alert("Exception while attempting to load\n\n" + e.toString());
		return(null);
	}
	return(content);
}

//&fxZFEvalCondition,&fxZFDateDiff:#1,#2;>;&fxPZFEval:5;N
function ZFDateDiff(obj, parameters){
	//parms = date1, date2, result type (Y= years, M= month, D= days)
	var d1, d2, type, timediff, date;
	var diff = new Date();
	var value = 0;
	
	var parms=parameters.split(',');
	if ( parms.length == 2 || parms.length == 3 )
	{
		if (parms.length == 2)
			parms.push('D'); //def return type

		//Get parms values
		d1   = parms[0].strip();	
		d2 	 = parms[1].strip();
		type = "D";// parms[2];  retorna dias solamente

		d1 = ZFGetFunction(obj, d1);
		d2 = ZFGetFunction(obj, d2);
		if ( d1 != "" && d2 != "" && ZFValidateDateValue(d1) && ZFValidateDateValue(d2) )
		{
			date = d1.split("/");
			var D1 = new Date(date[2],date[1]-1,date[0]);

			date = d2.split("/");
			var D2 = new Date(date[2],date[1]-1,date[0]);			
			diff.setTime(Math.abs(D1.getTime() - D2.getTime()));
			timediff = diff.getTime();

			switch(type) {
				//case "W":
					// weeks = Math.floor(timediff / (1000 * 60 * 60 * 24 * 7));
					// timediff -= weeks * (1000 * 60 * 60 * 24 * 7);
					//break;
				// case "Y":
					// value = Math.floor(timediff / (1000 * 60*60*24*)); 
					// break;
					
				// case "M":
					// value = Math.floor(timediff / (1000 * 60 * 60*24*)); 
					// alert( value +',' + timediff);					
					// break;
					
				case "D":
					value = Math.floor(timediff / (1000 * 60 * 60 * 24)); 
					break;
				//case "H":
					//return Math.floor(timediff / (1000 * 60 * 60)); 
					//break;
				//case "I":	
					// return  Math.floor(timediff / (1000 * 60)); 
					// timediff -= mins * (1000 * 60);
					//break;
				// case "S":
					// return Math.floor(timediff / 1000); 
					// timediff -= secs * 1000;
					// break;
			}
		}
		else
		{
		    return 0; //alguna fecha no valida
		}
	} else {
		return 0;
	}
	return value;
}

function ZFDateAge(obj, parameters){
	 var dtAsOfDate;
	 var dtBirth;
	 var dtAnniversary;
	 var intSpan;
	 var intYears;
	 var intMonths;
	 var date1, date2;
	
	 var parms=parameters.split(',');
	 if ( parms.length == 2)
	 {
 		 //Get parms values
		 var d1 = parms[0].strip();	
		 var d2 = parms[1].strip();
		 
		 if( d1 == "" || d2 == "") return 0;
		 
		 date1 = ZFGetFunction(obj, d1);
		 date2 = ZFGetFunction(obj, d2);	
	
	     dtAsOfDate = ZFGetDateObj( date1);
	     dtBirth = ZFGetDateObj( date2);
    	 
	     if( dtBirth == null || dtAsOfDate == null || dtBirth == dtAsOfDate)
		    return 0;
    	
	     // if as of date is on or after born date
	     if ( dtAsOfDate >= dtBirth )
	     {
	        // get time span between as of time and birth time
	        intSpan = ( dtAsOfDate.getUTCHours() * 3600000 +
	                    dtAsOfDate.getUTCMinutes() * 60000 +
	                    dtAsOfDate.getUTCSeconds() * 1000    ) -
	                  ( dtBirth.getUTCHours() * 3600000 +
	                    dtBirth.getUTCMinutes() * 60000 +
	                    dtBirth.getUTCSeconds() * 1000       );
	        // start at as of date and look backwards for anniversary 
    	
	        // if as of day (date) is after birth day (date) or
	        //    as of day (date) is birth day (date) and
	        //    as of time is on or after birth time
	        if ( dtAsOfDate.getUTCDate() > dtBirth.getUTCDate() || ( dtAsOfDate.getUTCDate() == dtBirth.getUTCDate() && intSpan >= 0 ) )
	        {
	           // most recent day (date) anniversary is in as of month
	           dtAnniversary = 
	              new Date( Date.UTC( dtAsOfDate.getUTCFullYear(),
	                                  dtAsOfDate.getUTCMonth(),
	                                  dtBirth.getUTCDate(),
	                                  dtBirth.getUTCHours(),
	                                  dtBirth.getUTCMinutes(),
	                                  dtBirth.getUTCSeconds() ) );
    	
	        }
	        // if as of day (date) is before birth day (date) or
	        //    as of day (date) is birth day (date) and
	        //    as of time is before birth time
	        else
	        {
	           // most recent day (date) anniversary is in month before as of month
	           dtAnniversary = 
	              new Date( Date.UTC( dtAsOfDate.getUTCFullYear(),
	                                  dtAsOfDate.getUTCMonth() - 1,
	                                  dtBirth.getUTCDate(),
	                                  dtBirth.getUTCHours(),
	                                  dtBirth.getUTCMinutes(),
	                                  dtBirth.getUTCSeconds() ) );
    	
	           // get previous month
	           intMonths = dtAsOfDate.getUTCMonth() - 1;
	           if ( intMonths == -1 )
	              intMonths = 11;
    	
	           // while month is not what it is supposed to be (it will be higher)
	           while ( dtAnniversary.getUTCMonth() != intMonths )
	              // move back one day
	              dtAnniversary.setUTCDate( dtAnniversary.getUTCDate() - 1 );
	        }
	        // if anniversary month is on or after birth month
	        if ( dtAnniversary.getUTCMonth() >= dtBirth.getUTCMonth() )
	        {
	           // years elapsed is anniversary year - birth year
	           intYears = dtAnniversary.getUTCFullYear() - dtBirth.getUTCFullYear();
	        }
	        // if birth month is after anniversary month
	        else
	        {
	           // years elapsed is year before anniversary year - birth year
	           intYears = (dtAnniversary.getUTCFullYear() - 1) - dtBirth.getUTCFullYear();
	        }
			    return intYears;
        }			    
     }
     else
     {
        return 0;			    
	 }
	 return 0;
}

function ZFGetDateObj( date){
	if ( typeof(date) == "string"){
		var v = date.split("/");
		if ( v.length == 3){
			date = new Date(v[2],v[1]-1,v[0]);	
		} else {
			date = new Date();
		}
		return date;		
	}
	if ( date instanceof Date)
		return date;
	return new Date();
}

//try{ var file = fso.OpenTextFile(fileName,2,-1,0);} catch (e) { alert( "1=>" + e.description);}	
//		var Tristate = -1; //-2= default, -1= unicode, 0= ascii
//		var Mode = 2; //2= writting, 3= Append 
//		fso.CreateTextFile( fileName, true);
//		var a = fso.Getfile( fileName);
//		//var file = a.OpenAsTextStream(ForWriting, Tristate);
//		var file = a.OpenAsTextStream(2,0);

//-------- ZENScripts

function ZFFocus(page){
	var oObject = $$('[name="content"]'); 	
	for (var i = 0; i < oObject.length; i++)
	{
		var obj = oObject[i];

		var pageid = obj.readAttribute("pageid");
		if (pageid == page )
		{	
			var controls = obj.getElementsBySelector('[name="thisControl"]');
			for (var j = 0; j < controls.length; j++)
			{	
				var control = controls[j];
				var focus = control.readAttribute("zffocus");
				if (focus == 'S' )
				{
					ZFFocusObj(control);
					break;
				}
			}
		}
	}
};
function ZFFocusObj(obj){
	var att = obj.readAttribute("zfcontrol");
	switch (att )
	{
	case "T":
		att = obj.readAttribute("zfid");
		tfirstname = "zffieldidcol_" + tId + "_1_1";
		tFirstControl = $(tfirstname);
		
		if (tFirstControl != null)
		{
			att = tFirstControl.readAttribute("zfcontrol");
			if (tFirstControl.zfcontrol != "L" )
				tFirstControl.select();
			tFirstControl.focus();	
		}
		break;
	case "M":
		break;
	case "L":
		obj.focus();
		break;	
	default:
		obj.select();
		obj.focus();
		break;
	}	
};
function ZFDefaultValues(borro){
    var obj;
	var oObject = $$('[name="thisControl"]');
	for (var i = 0; i < oObject.length; i++)
	{
		obj = oObject[i];
		ZFDefVal(obj ,borro);
	}	
};
function ZFDefVal(obj, borro){
	defaultvalue = "";
	var att = obj.readAttribute("zfdefault");
	if (att != null)
		defaultvalue = att;
	resultado = ZFGetFunctionResult(obj ,defaultvalue);

	att = obj.readAttribute("zfcontrol");
	var zfid = obj.readAttribute("zfid");
	switch ( att )
	{
		case "C":
			if (obj.checked == false || borro == "S")
				obj.checked = resultado;
			break;
		case "L":
			var j = ZFComboSelectValue(obj, resultado);
			if(borro == 'S') obj.options[0].selected ="1";
			break;
		case "T":
			columnscontrols = '[name="'+ "thisControl_" + zfid + '"]';
			var oColumns = $$(columnscontrols);
			for (var j = 0; j < oColumns.length; j++)
			{
				objColumn = oColumns[j];
				ZFDefVal(objColumn, borro);
			}
			break;
		case "M":
			checkscontrols = "thisControl_" + zfid;
			var oChecks = $$('[name="' + checkscontrols + '"]');
			for (var j = 0; j < oChecks.length; j++)
			{
				objCheck = oChecks[j];
				if (borro == "S")
					objCheck.checked = false;
			}			
			break;
		default:
			if (obj.value == "" || borro == "S")
				obj.value = resultado;
			break;
	}
};
//nuevocombo
function ZFComboSelectValue(obj,val){
	var i = -1;
	for(var j=0; j<obj.options.length; j++)
	{
		var v = obj.options[j].value;
		if(v == val)
		{
			//obj.options[i].defaultSelected = true;
			obj.options[j].selected = "1";
			i = j;
			break;
		}
	}
	return i;
}
function ZFSpanFormulas(){
	var oObject = $$('[id="ZFSpan"]');
	for (var i = 0; i < oObject.length; i++)
	{
		var obj = oObject[i];
		var formula = obj.readAttribute("zfformula");
		var spanvalue = ZFGetFunctionResult(obj ,formula);
		var replace = obj.innerHTML;
		var innerHTML = obj.innerHTML;
		innerHTML = innerHTML.replace(replace, spanvalue );
		obj.innerHTML = innerHTML;
	}
};
function ZFResetForm(){
	ZFClearValues();
	Load();
}
function ZFClearValues(){
	ZFClearBasic();
	ZFDefaultValues("S");
};
function ZFClearBasic(){
//	filename="";
	currentpage = new Number(0);
	zfValidaForm = false;
	aVal = new Array();
	aValOld = new Array();
	$('ZFSaved').value = 0;

	//clear check validated
	var obj = $('Validated');
	if (obj != null ) obj.checked = false;
}
//Validaciones
function ZFValidate(element){
	zfValidaForm = true;

	ZFFormulaReCalculate();

	var validationok = false;
	var message = "";

	ZFMsgClear();

	var oObject = $("Validated"); //zfDocument.getElementsBySelector('[id="Validated"]');
	
	validationok = ZFFieldsValidations();
	if ( validationok )
		validationok = ZFFormValidations();

	zfValidaForm = false;
	
	oObject.checked = validationok;
	
	//actualiza el campo de info del formulario
	actualInfo = ZFEvalText(null, displayInfo);
	oObject = $("INFO");
	oObject.setAttribute("displayInfo" , "actualInfo");
	oObject.setAttribute("fileName" , ZFFileName());
		
	try
	{
		UserAfterValidation();
	}
	catch(e)
	{
	}
	message = ZFMsgGet();
	if ( message != "")
		ZFMsgForm(element, message);

	if ( validationok)
	{
		ZFMsgForm(element, "Documento Validado");	
	}
};

function ZFFieldsValidations(){
	var fieldsOK = true;
	var oFields = $$('[name="thisControl"]');
	for ( var i=0; i < oFields.length; i++)
	{
		field = oFields[i];
		var control = field.readAttribute("zfcontrol");
		if (control != "T" && control != "M")
		{
			var zfid = field.readAttribute("zfid") ;
			var functionName = new Function("obj", "return Validate" + zfid + "(obj)" ) ;
			fieldsOK = functionName(field);
			if (fieldsOK == false )
				break;
		}
	}
	return fieldsOK;
};

//Tipo de Dato
function ZFValidateDate(obj ){
	if (obj != null){
		var datevalue = obj.value;	
		var ok = ZFValidateDateValue(datevalue);
		if (ok == true){
            if (datevalue.length == 8)
		        datevalue = datevalue.substring(0,6) + "20" + datevalue.substring(6,8);
			obj.value = datevalue;
		}
		return ok ;
	} else {
		return false;
	}
};
function ZFValidateDateValue(datevalue){	
	if (datevalue == "") 
		return true;

    if (datevalue.length == 8)
		datevalue = datevalue.substring(0,6) + "20" + datevalue.substring(6,8);

	var test1=(/^\d{1,2}\/?\d{1,2}\/\d{4}$/.test(datevalue));
	var date=datevalue.split('/');
	var d=new Date(date[2],date[1]-1,date[0]);
	var test2=(1*date[0]==d.getDate() && 1*date[1]==(d.getMonth()+1) && 1*date[2]==d.getFullYear());
	if (test1 && test2)
	{
		return true;
	}
	 
	return false;
}
function ZFStringToDate(s){
	if ( s == null || s == '' || !ZFValidateDateValue(s)) 
		return null;
	
	var date = s.split('/');
	var d = new Date(date[2],date[1]-1,date[0]);
	return d;	
}

function ZFValidateNumeric(obj){
	var numeric="";
	var moneyformat = "";
	numeric = obj.value;
	
	while (numeric.indexOf(milpoint) > -1 )
		numeric = numeric.replace(milpoint,"");

	while (numeric.indexOf(decpoint) > -1 )
		numeric = numeric.replace(decpoint,"");
	
	if (numeric == "") 
	{
		obj.value = "0";
		return true;
	}
	
	max = obj.readAttribute("LengthMax");
	if (numeric.length > max && max != 0)
		return false;

	moneyformat = obj.readAttribute("MoneyFormat");
	if ( moneyformat == "S" )
	{
		sign = "";
		if (numeric.indexOf('-') > -1 )
		{
			sign = "-";
			numeric = numeric.replace("-","");
		}
		decimals = new Number(obj.readAttribute("Decimals"));
		obj.value = sign + ZFFormatNum(obj, numeric, decimals);
	}
	else
		obj.value = numeric;

	return ! isNaN(numeric);

};
function ZFValidateTime(obj){
	var time=obj.value;
	if (time == "") 
		return true;
		
	time = time.split(':');
	if (time.length == 2)
	{	
		var hs = time[0];
		var min = time[1];
		
		if (0 <= hs && 0 <= min && hs < 24 &&  min < 60 )
			return true;
	}
	return false;
};


//Requeridos
function ZFValRequired(obj ){
	var req = obj.readAttribute("zfrequired");
	var control = obj.readAttribute("zfcontrol");
	var value = "";

	if (req != null && control != null)
	{
		if (req == "S" )
		{
			switch ( control )
			{
			case "L":
				value =obj.options[obj.selectedIndex].value;
				break;
			default:
				value = obj.value;
				break;
			}
			if ( value == "" )
				return false;
		}
	}
	return true;
};

//Para campos del tipo List que manejen filtros con respecto a otros campos.
function ZFOnFocus(element){
	var filter = element.readAttribute("zffiltersource");
	if (filter != null)
	{
		filter = ZFReplaceParms(element, filter);
		var len = element.options.length;
		var currentValue = "";
		try
		{
			currentValue = element.options[element.selectedIndex].value;
		}
		catch(e)
		{
		}
		for (var i=0 ; i < len; i++)
		{
			element.options.remove(0);
		}
		var optionsDiv = $('comboOptions' + element.readAttribute("zfid"));
		var options = optionsDiv.getElementsBySelector("ZFOPTION");
		len = options.length;
		for (var i=0; i < len; i++)
		{
			var optionFilter = options[i].readAttribute("zffilter") ;
			if (optionFilter == filter)
			{
				var oOption = document.createElement("OPTION");
				element.options.add(oOption);
				oOption.innerHTML = options[i].readAttribute("description");
				oOption.value = options[i].readAttribute("value");
			}
		}
		element.value = currentValue;
	}
};
//Ocultar y deshabilitar campos
function ZFHideObjects(fieldcodes){
	if (fieldcodes != "" )
	{
		var ids=fieldcodes.split(',');

		for (var i = 0; i < ids.length; i++)
		{
			var id = ids[i];
			if (id.substring(0, 1 ) == "#" )
			{
				id = id.replace("#","");
				var obj = $("ZenField" + id); 
				if (obj != null)
					obj.style.visibility = "hidden";
			}
			else
			{
				var obj = $$('[id="' + id + '"]');
				for (var j = 0; j < obj.length; j++)
				{
					obj[j].style.visibility = "hidden";
				}
			}
		}
	}
};
function ZFShowObjects(fieldcodes){
	if (fieldcodes != "" )
	{
		var ids=fieldcodes.split(',');

		for (var i = 0; i < ids.length; i++)
		{
			id = ids[i];
			if (id.substring(0, 1 ) == "#" )
			{
				id = id.replace("#","");
				var obj = $("ZenField" + id ); 
				if (obj != null)
					obj.style.visibility = "visible";
			}	
			else
			{
				var obj = $$('[id="' + id + '"]');
				for (var j = 0; j < obj.length; j++)
				{
					obj[j].style.visibility = "visible";
				}
			}
		}
	}
};
function ZFDisableObjects(objects ){
	if (objects != "" )
	{
		var ids=objects.split(',');

		for (var i = 0; i < ids.length; i++)
		{
			var id = ids[i];
			if (id.substring(0, 1 ) == "#" )
			{
				id = id.replace("#","");
				id = id.replace(" ","");
				id = "ZenField" + id;
			}
			
			var obj = $$('[id="' + id + '"]');
			
			for (var j = 0; j < obj.length; j++)
			{
				var oObj = obj[j];
				oObj.disabled = true;
				ZFDisableObjsbyName(oObj,"thisControl");
			}
		}
	}
};
function ZFDisableObjsbyName(obj , oName){
	var oObj = obj;
	if (oObj != null )
	{
		var objects = oObj.getElementsBySelector('[name="' + oName + '"]');
		if (objects != null)
		{
			if (objects.length != null )
			{
				for (var k = 0; k < objects.length; k++)
				{
					objects[k].disabled = true;
					ZFDefVal(objects[k] ,"S");
				}
			}
			else
			{
				objects.disabled = true;
				ZFDefVal(objects ,"S");
			}	
		}
	}
};
function ZFEnableObjects(objects ){
	if (objects != "" )
	{
		var ids=objects.split(',');

		for (var i = 0; i < ids.length; i++)
		{
			var id = ids[i];
			if (id.substring(0, 1 ) == "#" )
			{
				id = id.replace("#","");
				id = id.replace(" ","");
				id = "ZenField" + id;
			}

			var obj = $$('[id="' + id + '"]');
			for (var j = 0; j < obj.length; j++)
			{
				var oObj = obj[j];
				oObj.disabled = false;
				ZFEnableObjsbyName(oObj,"thisControl");
			}
		}
	}
};
function ZFEnableObjsbyName(obj , oName){
	var oObj = obj;
	if (oObj != null )
	{
		var objects = $$('[name="' + oName + '"]');
		for (var k = 0; k < objects.length; k++)
		{
			objects[k].disabled = false;
		}
	}
};
//Acumulacion de mensajes
function ZFMsgAdd(msg){
	var textAreaMsg = $("Msg"); 
	var text = msg;

	if (textAreaMsg )
	{
		if (text != "" )
			textAreaMsg.value +=text+"\n";
	}
};
function ZFMsgClear(){
	var textAreaMsg = $("Msg"); 
	var text = "";

	if (textAreaMsg )
	{
		textAreaMsg.value = text;
	}
};
function ZFErrorMsg(code){
	return "";	
};
function ZFMsgGet(){
	var textAreaMsg = $("Msg"); 
	var text = "";

	if (textAreaMsg )
	{
		 text = textAreaMsg.value;
	}
	return text;
};
function ZFGetParent(obj , ParentId){
	var loop = true;
	var par = obj;
	var oParent = null;
	while ( loop )
	{
		par = par.parentElement;
		if (par != null)
		{
			if (par.id == ParentId )
			{
				loop = false;
				oParent = par;
			}
		}
		else
		{
			loop = false;
		}
	}
	return oParent;
};
//Condiciones
function ZFValidateCondition(obj, op, expression ,type){
	var value = obj.value;
	var compresult = false;

	if (value == "") 
		return true;
	
	//veo si es alguna funcion en este caso devuelve el valor resultante para luego comparar
	expression = ZFGetFunctionResult(obj, expression);
	compresult = ZFCompare(value , op, expression , type );

	return compresult;
};
//Recalcula las Formulas
function ZFFormulaReCalculate(){
	var oObject = $$('[name="thisControl"]');

	for (var i = 0; i < oObject.length; i++)
	{
		var obj = oObject[i];
		var formula = obj.readAttribute("zfformula");
		if (formula != null && formula != "")
		{
			var resultado = ZFGetFunctionResult(obj, formula);
			obj.value = resultado;
		}
	}	
};
function FCalc(zfid){
 if(zfValidaForm == false){
	//var obj = $("zffieldid" + zfid );
	var obj = aVal[zfid];

	if (obj != null )
	{
		var formula = obj.readAttribute("zfformula");
		if (formula != null && formula != "")
		{
			var resultado = ZFGetFunctionResult(obj, formula);
			obj.value = resultado;
		}
	}
 }
};


//Funciones 
function ZFGetFunctionResult(obj, expression){
	//obtengo nombre de funcion y parametros
	if (expression != null)
	{
		var pos = expression.indexOf(',',0);
		if (pos != -1 )
		{
			var zffunctionname = expression.substring(0, pos );
			var zffunctionparms = expression.substring(pos + 1,expression.length);
		}
		else
		{
			var zffunctionname = expression;
			var zffunctionparms = "";
		}
		
		//verifico si es una funcion estandar o de usuario
		switch (zffunctionname.substring(0,4) )
		{
			case "&fxP": //es una funcion estandar ZF
				zffunctionname = zffunctionname.replace("&fxP","").toUpperCase();
				switch (zffunctionname)
				{
					case "ZFDATEADD" :
						return ZFDateAdd(obj, zffunctionparms);
						break; //EL ZFDATESUBTRACT ES LO MISMO PASANDOLE COMO PARAMETRO EL NUMERO NEGATIVO.
					case "ZFDATEDIFF" :
						return ZFDateDiff(obj, zffunctionparms);
						break; 
				    case "ZFDATEAGE" :
						return ZFDateAge(obj, zffunctionparms);
						break; 				    
					case "ZFEVAL" :
						resultado = ZFEval(obj, zffunctionparms);
						return resultado;
						break; //Evalua la expresion de parmetros
					case "ZFEVALTEXT" :
						resultado = ZFEvalText(obj, zffunctionparms);
						return resultado;
						break; //Evalua la expresion de texto de parametros
					case "ZFIF" :
						resultado = ZFIF(obj, zffunctionparms);
						return resultado;
						break; //Evalua condicion y devuelve expresion correspondiente
				}		
				return expression;
				break;
			case "&fxZ": //es una fx ZF
				zffunctionname = zffunctionname.replace("&fx","");
				return eval(zffunctionname)(obj, zffunctionparms );
				break;
		}	
		//si no es una funcion estandar o de usuario verifico si es una funcion publica disponible 
		expression = expression.replace("&fx","");
		expression = ZFGetFunction(obj, expression);
	}
	return expression;
};

//Mascaras y controles en presskey
function ZFNumericFormat(obj, maxlength, decimals ,e){
	var milSep = milpoint;
	var decSep = decpoint;
	
	var sep = 0; 
	var key = ''; 
	var i = j = k = 0; 
	var len = 0; 
	var strCheck = '0123456789'; 
	var aux = aux2 = ''; 
	var whichCode = e.which ;
	if (whichCode == null)
		whichCode = e.keyCode; 
	
    //enter
	if (whichCode == 13 || whichCode == 0 || whichCode == 8) 
		return true; // Enter 

	//caracter valido con respecto a cadena strCheck
	key = String.fromCharCode(whichCode); // Get key value from key code
	if (strCheck.indexOf(key) == -1) 
		return false; // Not a valid key 

	//largo del numero
	number = obj.value.replace(",","").replace(".","").length; 
	if (number.length > maxlength && maxlength != 0)
		return false; //Supera largo

	//formateo con decimales

	len = obj.value.length;
	for(i = 0; i < len; i++) 
		if ((obj.value.charAt(i) != '0') && (obj.value.charAt(i) != decSep)) 
		break; 
		
	aux = ''; 
	for(; i < len; i++) 
	if (strCheck.indexOf(obj.value.charAt(i))!=-1)
		aux += obj.value.charAt(i); 
		
	aux += key; 
	len = aux.length; 
    
	if (len == 0) 
		obj.value = ''; 
	
	if ( 0 < len && len < decimals  ) 
	{
		ceros = "";
		for(var k=1; k < decimals - len + 1 ; k++)
		{
			ceros += '0';
		}
		obj.value = '0'+ decSep + ceros + aux;
	}

	if (len == decimals) 
		obj.value = '0'+ decSep + aux; 

	if (len > decimals) 
	{ 
		aux2 = ''; 
		if ((len - decimals - 3 ) > 0 )
		{
		aux3 = aux.substring(0,len - decimals );
		for (j = 0, i = len - decimals -1; i >= 0 ; i--)
		{ 
			if (j == 3) 
			{ 
				aux2 = milSep + aux2; 
				j = 0; 
			} 
				aux2 = aux3.charAt(i) + aux2; 
			j++; 
		}
		}
		if ((len - decimals - 3 ) < 0 )
		{
		for (i = 0 ; i < len - decimals ; i++) 
		{ 
			aux2 += aux.charAt(i);
		}	
		}
		if ((len - decimals - 3 ) == 0 )
		{
		for (i = 0 ; i < 3 ; i++) 
		{ 
			aux2 += aux.charAt(i);
		}	
		}
		obj.value = ''; 
		len2 = aux2.length; 
		for (i = len2-1 ; i >= 0; i--) 
			obj.value = aux2.charAt(i) + obj.value; 

		if (decimals > 0)
			obj.value += decSep + aux.substr(len - decimals, len); 
	} 
    return false; 
};
function ZFFormatNum(obj, value , decimals){
	var milSep = milpoint;
	var decSep = decpoint;
	var strCheck = '0123456789';
	var aux = aux2 = ''; 
	var len = i = 0;

	//Si no lleva decimales y empieza con 0s los elimino
	len = value.length;	
	if (decimals == 0)
	{
			while (value.substring(0,1) == "0" && len != 1)
			{
				value = value.substring(1,len);
			}
	}

	//formateo con decimales

	aux = value; 

	//formateo con decimales
	
	len = aux.length;
    
	if (len == 0) 
		value = ''; 
	
	if ( 0 < len && len < decimals  ) 
	{
		ceros = "";
		for(var k=1; k < decimals - len + 1 ; k++)
		{
			ceros += '0';
		}
		value = '0'+ decSep + ceros + aux;
	}

	if (len == decimals) 
		value = '0'+ decSep + aux; 


	if (len > decimals) 
	{ 
		aux2 = ''; 
		if ((len - decimals - 3 ) > 0 )
		{
			aux3 = aux.substring(0,len - decimals );
			for (j = 0, i = len - decimals -1; i >= 0 ; i--) 
			{ 
				if (j == 3) 
				{ 
					aux2 = milSep + aux2; 
					j = 0; 
				} 
		      		aux2 = aux3.charAt(i) + aux2; 
				j++; 
			}
		}

		if ((len - decimals - 3 ) < 0 )
		{
			for (i = 0 ; i < len - decimals ; i++)
			{ 
				aux2 += aux.charAt(i);
			}	
		}

		if ((len - decimals - 3 ) == 0 )
		{
			for (i = 0 ; i < 3 ; i++) 
			{ 
				aux2 += aux.charAt(i);
			}	
		}
		value = ''; 
		len2 = aux2.length; 
		for (i = len2-1 ; i >= 0; i--) 
			value = aux2.charAt(i) + value; 

		if (decimals > 0)
			value += decSep + aux.substr(len - decimals, len);
	} 
	return value; 
};
function ZFMod(a ,b ){
	var mod = 0;
	if (b != 0 )
		mod = a - Math.floor(a/b);
	return mod;
};
function ZFDateFormat(obj ,e){
	var sep = 0; 
	var key = ''; 
	var i = 0; 
	var len = datelen = 0; 
	var strCheck = '0123456789'; 
	var aux = aux2 = ''; 
	var whichCode = e.which ; 
	if (whichCode == null)
		whichCode = e.keyCode; 
	var maxlength = 8;

	if (whichCode == 13 || whichCode == 0 || whichCode == 8) 
		return true; // Enter 
		
	key = String.fromCharCode(whichCode); // Get key value from key code     
	if (strCheck.indexOf(key) == -1) 
		return false; // Not a valid key 
		
    datelen = obj.value.replace("/","").length; 
    if (datelen > maxlength)
		return false; //Supera largo 8
	
	len = obj.value.length; 
	
	for(i = 0; i < len; i++) 
		aux += obj.value.charAt(i);	
		if (len == 2 || len == 5)
			aux += "/";	
	aux += key; 
	obj.value = aux;      
	return false; 
};
function ZFTextFormat(obj, maxlength ,e){
	var textlen = obj.value.length;
	if (textlen > maxlength && maxlength != 0)
		return false; //Supera largo 
	return true; 
};
function ZFTimeFormat(obj ,e){
	var key = ''; 
	var i = 0; 
	var len = timelen = 0; 
	var strCheck = '0123456789'; 
	var aux = ''; 
	var whichCode = e.which ; 
	if (whichCode == null)
		whichCode = e.keyCode; 
	var maxlength = 3;

	if (whichCode == 13 || whichCode == 0 || whichCode == 8)
		return true; // Enter 

	key = String.fromCharCode(whichCode); // Get key value from key code
	if (strCheck.indexOf(key) == -1) 
		return false; // Not a valid key 
		
	timelen = obj.value.replace(":","").length;
	if (timelen > maxlength)
		return false; //Supera largo 4
	
	len = obj.value.length; 
	
	for(i = 0; i < len; i++) 
		aux += obj.value.charAt(i);
		if (len == 2 )
			aux += ":";	
	aux += key; 
	obj.value = aux;
	return false;
};
//Funciones estandares ZF
function ZFDateAdd(obj ,parameters){
	var parms=parameters.split(',');
	if ( parms.length == 2 )
	{
		//var initialdate = Trim(parms[0]);
		var initialdate = parms[0].strip();
		
		//Si es una funcion ZF devuele el resultado sino queda con el mismo valor
		initialdate = ZFGetFunction(obj, initialdate);
		var daystoaddch = parms[1];
		daystoaddch = ZFGetFunction(obj, daystoaddch);
		var daystoadd = new Number(daystoaddch);
		
		initialdate = initialdate.split('/');
		var dateini=new Date(initialdate[2],initialdate[1]-1,initialdate[0]);
		dateini.setDate(dateini.getDate() + daystoadd);		
		var dia = (dateini.getDate() < 10) ? "0" + dateini.getDate().toString() : dateini.getDate().toString();   
		var mes = ((dateini.getMonth() + 1 ) < 10) ? "0" + (dateini.getMonth() + 1 ).toString() : (dateini.getMonth() + 1 ).toString();
		if (isNaN(dia) || isNaN(mes) )
			return "";
		var fecha = dia + "/" + mes + "/" + dateini.getFullYear().toString();
		return fecha;
	}
	return "";
};
function ZFEval(obj, parameters ){
	//recibo en parameters algo del tipo #1 + #8 - 785 etc debo sustituir #xx por el valor del campo xx
	var expression = ZFReplaceParms(obj, parameters);
	//se redondea segun los decimales que tiene el campo
	var decimals = 0;

	if ( obj != null)
	{
		if (obj.readAttribute("Decimals") != null )
			decimals = obj.readAttribute("Decimals");
	}	
	else
	{
		if ( decpordef != "")
			decimals = decpordef;
	}
	var dectoround = Math.pow(10,decimals);
	
		try
		{
			var resultado = eval(expression);

			if (isNaN(resultado))
				return "0";
		
			resultado = Math.round(resultado * dectoround ) / dectoround;
			resultconformato = resultado.toString();
			
			//manejo del signo para formatear
			sign = "";
			if (resultconformato.indexOf('-') > -1 )
			{
				sign = "-";
				resultconformato = resultconformato.replace("-","");
			}
			
			//saco punto decimal
			pos = resultconformato.indexOf('.');
			if ( pos > -1 )
			{
				resultconformato = resultconformato.replace('.',"");
				cantceros = decimals - resultconformato.length + pos;
			}
			else
			{
				cantceros = decimals;
			}
			
			for (var i=1; i <= cantceros; i++)
				resultconformato += "0";
			
			resultconformato = sign + ZFFormatNum(obj, resultconformato, decimals );
			return resultconformato;
		}
		catch(e)
		{
			return obj.value;
		}
	return "0";
};
function ZFEvalText(obj, text){
	var newText = ZFReplaceParms(obj, text);
	return newText;
};

//Wrapper ZFIF (Workaround IF fx)
function PZFIF(o,p){
	return ZFIF(o,p);
};
function PZFIFCond(o,p){
	return ZFIFCond(o,p);
};

function ZFIF(obj, parameters){
	var expression = ZFReplaceParms(obj, parameters);
	var parms = expression.split(',');
	if ( parms.length = 3 )
	{
		var condition = parms[0];
		var expressiontrue = parms[1];
		var expressionfalse = parms[2];
		
		var cond = ZFEvalCondition(obj, condition);
		if (cond )
		{
			expressiontrue = expressiontrue.replace(':',',');
			return ZFGetFunctionResult(obj, expressiontrue);
		}
		else
		{
			expressionfalse = expressionfalse.replace(':',',');
			return ZFGetFunctionResult(obj, expressionfalse);
		}
	}
	return "";
};
function ZFIFCond(obj, parameters){
	var expression = ZFReplaceParms(obj, parameters);
	var parms = expression.split(',');
	if ( parms.length = 3 )
	{
		var condition = parms[0];
		var expressiontrue = parms[1];
		var expressionfalse = parms[2];
		
		var cond = ZFEvalCondition(obj, condition);
		if (cond )
		{
			expressiontrue = expressiontrue.replace(':',',');
			return ZFEvalCondition(obj, expressiontrue);
		}
		else
		{
			expressionfalse = expressionfalse.replace(':',',');
			return ZFEvalCondition(obj, expressionfalse);
		}
	}
	return true;
};
function ZFEvalCondition(obj, condition){
	var orConditions = condition.split('||');
	var lenOr = orConditions.length;

	var result = false;
	for (var i = 0 ; i < lenOr ; i++)
	{
		var orCondition = orConditions[i];
		
		var andConditions = orCondition.split('&&');
		var lenAnd = andConditions.length;
		
		orResult = true;
		for (var j = 0; j < lenAnd ; j++)
		{
			var andCondition = andConditions[j];
			var andResult = ZFEvalSimpleCondition(obj, andCondition );
			if(bDeb==1)alert('ZFEvalCond. cond='+ andCondition + ',res='+andResult);
			if ( andResult == false )
			{
				orResult = false;
				break;
			}
		}
		if (orResult == true)
		{
			result = true;
			break;
		}
	}
	return result;
};

function ZFEvalSimpleCondition(obj, condition ){
	var conditionsplit = condition.split(';');
	var expression1 = "";
	var operator = "";

	var expression2 = "";
	var result1 = "";
	var result2 = "";
	var type = "";
	if (obj != null)	
	{
		type = 	obj.readAttribute("zftype");
	}
	if (conditionsplit.length == 4)	
	{
		type = conditionsplit[3]; //indica el tipo de comparacion
	}

	if (conditionsplit.length >= 3)
	{
		expression1 = conditionsplit[0].strip();
		expression1 = expression1.replace(':',',');
		operator = conditionsplit[1].strip();
		expression2 = conditionsplit[2].strip();		
		expression2 = expression2.replace(':',',');
		
		result1 = ZFGetFunctionResult(obj, expression1);
		result2 = ZFGetFunctionResult(obj, expression2);
		
		var r = ZFCompare(result1, operator, result2, type);
if(bDeb==1)alert('ZFSimpCond. '+ expression1 + '=' + result1 + ','+ expression2 + '=' + result2 + '=>' +r);		
		return r;
	}
	if (conditionsplit.length == 1)
	{
		var conditionsimple = conditionsplit[0].strip();
		switch ( conditionsimple )
		{
			case "true":
				return true;
				break;
			default :
				return false;
				break;
		}
	}
	return false;
};
function ZFCompare(expression1, op, expression2 , type){
if (bDeb==1)alert('ZFComp. '+expression1+' ' + op+ ' ' + expression2 + ',type='+ type);
	switch ( type )
	{
		//Si es fecha debo generar datos de tipo fecha para luego comparar
		case "F":
			var date=expression1.split('/');
			if(date == null || date.length != 3)
			{
				var uservalue= new Date(0,0,0);
			}
			else
			{
				var uservalue=new Date(date[2],date[1]-1,date[0]);
			}
			
			var date2=expression2.split('/');
			if(date2 == null || date2.length != 3)
			{	
				var expressionvalue= new Date(0,0,0);
			}
			else
			{
				var expressionvalue=new Date(date2[2],date2[1]-1,date2[0]);
			}
			if(bDeb==1)alert("ZFComp2. UserValue="+uservalue+", expValue="+expressionvalue);
			switch (op) 
			{
				case "=" :
					if ( uservalue < expressionvalue)
						return false;
					if ( uservalue > expressionvalue)
						return false;
					return true;
					break;
				case "<=" :
					if (uservalue <= expressionvalue) 
						return true;
					break;
				case "<" :
					if (uservalue < expressionvalue) 
						return true;
					break;
				case ">=" :
					if (uservalue >= expressionvalue) 
						return true;
					break;	
				case ">" :
					if (uservalue > expressionvalue) 
						return true;
					break;	
				case "!=" :
					if ( uservalue < expressionvalue)
						return true;
					if ( uservalue > expressionvalue)
						return true;
					return false;
					break;
			}
			break;
		//Si es numerico debo generar datos de tipo numerico para luego comparar
		case "N":
			var uservalue = new Number(ZFNumericValue(expression1));
			var expressionvalue = new Number(ZFNumericValue(expression2));
			
			switch (op) 
			{
				case "=" :
					if ( ! (uservalue < expressionvalue || uservalue > expressionvalue ) )
						return true;
					break;
				case "<=" :
					if (uservalue <= expressionvalue) 
						return true;
					break;
				case "<" :
					if (uservalue < expressionvalue) 
						return true;
					break;
				case ">=" :
					if (uservalue >= expressionvalue) 
						return true;
					break;
				case ">" :
					if (uservalue > expressionvalue) 
						return true;
					break;
				case "!=" :
					if ( uservalue > expressionvalue ) 
						return true;
					if ( uservalue < expressionvalue ) 
						return true;
					break;
			}
			break;
		//para campos caracter
		default:
			var uservalue = expression1.toString();
			var expressionvalue = expression2.toString();
			
			switch (op) 
			{
				case "=" :
					if (uservalue == expressionvalue) 
						return true;
					break;
				case "<=" :
					if (uservalue <= expressionvalue) 
						return true;
					break;
				case "<" :
					if (uservalue < expressionvalue) 
						return true;
					break;
				case ">=" :
					if (uservalue >= expressionvalue) 
						return true;
					break;
				case ">" :
					if (uservalue > expressionvalue) 
						return true;
					break;
				case "!=" :
					if (uservalue != expressionvalue) 
						return true;
					break;
			}
			break;
	}

	return false;
};
//Funciones disponibles en ZenForms
function ZFGetFunction(obj, name ){
	var functionvalue = "";
	var functionname = name.strip();
	if  (functionname == "" )
	{
		if (obj != null)
		{
			var type = obj.readAttribute("zftype");
			switch ( type )
			{
				case "N":
					return "0";
					break;
				default:
					return "";
					break;
			}
		}
	}
	switch (functionname.substring(0,1))
	{
		case "&": //es una funcion disponible de ZF
			zffunction = functionname.replace("&","").toUpperCase();

			switch (zffunction)
			{
				case "TODAY":
					functionvalue = ZFToday();
					break;	
				case "YEAR":
					functionvalue = ZFYear();
					break;
				case "MONTH":
					functionvalue = ZFMonth();
					break;
				case "DAY":
					functionvalue = ZFDay();
					break;	
				case "PAGENUMBER":
					functionvalue = ZFPageNumber();
					break;	
				case "PAGECOUNT":
					functionvalue = ZFPageCount();
					break;
			}
			break;
		case "#":
			var fieldcode = functionname.replace("#","");
			functionvalue = ZFFieldValue(obj,fieldcode);
			break;
		default:
			functionvalue = functionname;
			break;
	}	
	return functionvalue;
};
function ZFToday(){
	var ahora = new Date();
	var dia = (ahora.getDate() < 10) ? "0" + ahora.getDate().toString() : ahora.getDate().toString();   
	var mes = ((ahora.getMonth() + 1 ) < 10) ? "0" + (ahora.getMonth() + 1 ).toString() : (ahora.getMonth() + 1 ).toString();
	var today = dia + "/" + mes + "/" + ahora.getFullYear().toString();
	return today;
};
function ZFDay(){
	var ahora = new Date();
	var dia = (ahora.getDate() < 10) ? "0" + ahora.getDate().toString() : ahora.getDate().toString();   
	return dia;
};
function ZFMonth(){
	var ahora = new Date();
	var mes = ((ahora.getMonth() + 1 ) < 10) ? "0" + (ahora.getMonth() + 1 ).toString() : (ahora.getMonth() + 1 ).toString();
	return mes;
};
function ZFYear(){
	var ahora = new Date();				
	var year = ahora.getFullYear().toString();
	return year;
};
function ZFPageNumber(){
	var pagenumber = currentpage + 1;
	return pagenumber;
};
function ZFPageCount(){
	var oObject = $$('[name="content"]');
	
	return oObject.length;	
};
//Barra de Botones
function ZFPrint(pages){
	ZFPrintPreview();
	if(pages == null || pages == '')
	{
		window.print();	//actual
	}
	else
	{		
		if(pages.toLowerCase() == 'all')
		{
			//for (var i = pagesSel.length - 1; i >= 0; i--)
			//{
			//	var pagenumber = new Number(pagesSel[i]);		
			ZFPrintSilent(pages); //todas
		}
		else
		{
			var pagesSel = pages.split(',');
			if(pagesSel.length == 1) //una especifica
			{
				var pagenumber = new Number(pagesSel[0]);
				var prevpage = currentpage;
				GoTo(pagenumber);
				if (currentpage == pagenumber) //nro correcto
				{
					window.print();
					GoTo(prevpage);
				}
			}
			else
			{
			//rangos
			}
		}
	}

};

function ZFPrintSilent(pages)
{
	//old values
	var hpos = $('header').style.position;
	var htop = $('header').style.top;
	var hvis = $('header').style.visibility;	
	var fpos = $('footer').style.position;
	var ftop = $('footer').style.top;
	var fvis = $('footer').style.visibility;
	var aPagVal = new Array();
	
	//header
	$('header').style.position = "relative";
	$('header').style.top = 0;
	$('header').style.visibility = "hidden";	
		
	//copia de header fuera del DOM
	var h = $('header').cloneNode(true);
	h.id = 'prnHeader';
	h.style.position = "relative";
	h.style.top = 0;
	h.removeChild(h.firstChild);

	//footer
	$('footer').style.position = "relative";
	$('footer').style.top = 0;
	$('footer').style.visibility = "hidden";
	//copia de footer
	var f = $('footer').cloneNode(true);
	f.id = 'prnFooter';

	//for each page
	var objs = $$('[name="content"]');
	for( var i=0 ; i<objs.length; i++)
	{
		var h2 = h.cloneNode(true);
		h2.id = 'prnHPag' + i;
		h2.style.visibility = "visible";
		if(i>0) h2.style.pageBreakBefore = "always";
		/*if (i>1){
			f.id = 'prnFPag' + (i-1);
			objs[i].parentNode.insertBefore(f,objs[i]);
		}*/
		objs[i].parentNode.insertBefore(h2, objs[i]);

		//page olds
		var pPagOneVal = new Array(objs[i].style.visibility,objs[i].style.top,objs[i].style.position);				
		aPagVal[i] = pPagOneVal;
		//set "content"
		objs[i].style.visibility = "visible";
		objs[i].style.top = 0;
		objs[i].style.position = "relative";
	}

	//otros
	$('Validated').style.visibility ="hidden";

	window.print();

	//undo
	//header y footer	
	$('header').style.position = hpos;
	$('header').style.top = htop;
	$('header').style.visibility = hvis;		
	$('footer').style.position = fpos;
	$('footer').style.top = ftop;
	$('footer').style.visibility = fvis;

	h = null;
	h2 = null;

	//pages
	for( var i=0 ; i<objs.length; i++)
	{
		$('prnHPag' + i).remove();	
		
		objs[i].style.visibility = aPagVal[i][0];
		objs[i].style.top = aPagVal[i][1];
		objs[i].style.position = aPagVal[i][2];
	}	
	aPagVal = null;
	GoTo(currentpage);
}


function ZFPrintPreview(){
	var oObject = document.getElementsByTagName("table");
	if (oObject != null)
	{
		if (oObject.length != null)
		{

			for (var i = 0; i < oObject.length; i++)
			{
				obj = oObject[i];
				if (obj.NoPrint == 'S' )
				{
					obj.style.display = "none";
				}
			}
		}
		else
		{
			obj = oObject;
			if (obj.NoPrint == 'S' )
			{
				obj.style.display = "none";
			}
		}
	}	
	//habilitar el boton de Vista en Preview WorkView el element se llama 
};
function ZFPreviewShowHide(){
	var oObject = $$('[NoPrint = "S"]');
	for (var i = 0; i < oObject.length; i++)
	{
		obj = oObject[i];
		if ( obj.style.display == "none" )
			obj.style.display = "block";
		else
			obj.style.display = "none";
	}
};

//Devolver Nombre Archivo
function ZFFileName(){
	var name = document.location;
	//lugar y nombre del archivo a guardar
	var aux = name.toString();
	aux = aux.replace("file:///","");
	for (var i = 0; i < 20; i++)
	{
		aux = aux.replace("%20"," ");
	}
	var auxsplit = aux.split('/');
	var len = 0;
	var filenamesug = filename;
	filenamesug = ZFReplaceParms(null, filenamesug);

	while (filenamesug.indexOf("/") > -1 )
		filenamesug = filenamesug.replace("/","");

	len = auxsplit.length;
	var i = 0;
	aux = "";
	while ( i < len)
	{
		switch (i)
		{
		case 0:
			aux = auxsplit[i];
			break;
		case len-1:
			//obtengo el nombre sugerido desde zeneditor
			aux += "\\" + filenamesug;
			break;
		default:
			aux += "\\" + auxsplit[i];
		}
		i += 1;		
	}
	return aux;	
};

function ZFFileNameLeaf(){
	var name = document.location;
	//lugar y nombre del archivo a guardar
	var aux = name.toString();
	aux = aux.replace("file:///","");
	for (var i = 0; i < 20; i++)
	{
		aux = aux.replace("%20"," ");
	}
	var auxsplit = aux.split('/');
	var len = 0;
	len = auxsplit.length;
	var filenamesug = auxsplit[len-1];
	filenamesug = filenamesug.replace(".htm","");
	return filenamesug;	
};

function ZFSave(element, dialog){
		try{ 
			$('ZFSaved').value = 1;

			if(navigator.userAgent.indexOf("Firefox")!=-1){ // toma el str si estamos usando el FireFox
				var str = document.documentElement.innerHTML;
			} 
			else{ // toma el str si estamos usando IE

				var str = document.documentElement.outerHTML;
				var cu="_coun" + "ted" + '="undefined"';
				while ( str.indexOf(cu) > -1 ){
					str = str.replace(cu, "");
				}
			}
			
			var fileName = ZFFileName();

			ZFSaveFile(fileName, str, dialog );

		} catch(e){
			alert("No se puedo salvar el formulario");
		}
};

function ZFPrueba(){
	document.getElementById('zffieldid331').innerHTML = '<INPUT class=DGICampoNum onkeypress=return(ZFFieldFormat331(this,event)) id=zffieldid331 onblur=Validate331(this);Rules331(this) style="LEFT: 0px; WIDTH: 75%; TOP: 0px" onhelp="ZFFieldHelp();return false" tabIndex=620 onchange=ZFModified() value=11111111 name=thisControl zfid="331" zfexport="S" zflabelcode="982" zfidext="982" zfextinf="" zfcontrol="E" zfformula="" zfrequired="N" zftype="N" zfdefault="" zfhelp="" zffocus="N" LengthMax="0" Decimals="0" MoneyFormat="N" ></INPUT> ';
}


function ZFSaveToPrint(element){
	var w = window.open("about:blank", 'ZFPrint',    "height=200,width=400,status=yes,toolbar=no,menubar=no,location=no");

}

function ZFSaveXML(element,dialog){
	
	if(dialog == null) dialog = true; //default para envio es con dialogo
	
	var SaveError = false;
	var SaveCase = '';
	
		//bak
		try{
			ZFSave( element, false);
		} catch(e) {
		}
	
		var oObject = $("Validated");
		
		try{
			ZFValidate(element);
		} 
		
		catch(e){
			if(oObject != null) oObject.checked = false;
		}	

	if (oObject != null)
		{
			if (oObject.checked )
			{
				try	{
					UserBeforeSaveXML();
				}catch(e){
					if(bDeb==1)
						alert('Before Save:' + e.description);
				}
				
				try{
					var vals = GenerateXmlValues();
					var amp = "&";
					while (vals.indexOf(amp) > -1 )
						vals = vals.replace(amp,"");
					str = vals;	


		
	  			 if(Prototype.Browser.IE){
		   
					//  reduce overhead   
					var w = window.frames.w;  
					if( !w ) 
					{   
						w = document.createElement( 'iframe' );   
						w.id = 'w';   
						w.style.display = 'none';   
						window.document.body.insertBefore( w );   
						w = window.frames.w;   
						if( !w ) 
						{    
							w = window.open( '', '_temp', 'width=100,height=100' );   
							if( !w ) 
							{     
								window.alert( 'No se pudo crear el archivo.' ); 
								return false;    
							}   
						}  
					}   
					var d = w.document; 
					d.open( 'text', 'replace' );  
					d.charset = "iso-8859-1";
					d.write(str);
					d.close();
					
					var fileName = ZFFileName();
					var fileNameToSave = fileName + ".xml";

					if( d.execCommand( 'SaveAs', null, fileNameToSave ) )
					{
						window.alert( "El documento se guardo correctamente y esta listo para su envio." );					
					}
					else
					{
						var msg = "Atencion: el archivo no pudo ser generado." + "\n" + "Pulse Aceptar, si desea reintentar la operacion, en este caso el archivo quedara sin extension la cual debera agregar manualmente, por ej. .xml" + "\n" + "Pulse Cancelar, para cancelar la operacion";
						if  (confirm(msg))
						{
							if( d.execCommand( 'SaveAs', null, fileName ) )
							{
								window.alert( "El documento se guardo correctamente y esta listo para su envio." );  
							}
							else
							{
								window.alert( 'No se pudo salvar el documento' );
								SaveError = true;
								SaveCase = "noenviado";
							}
						}
					}
					w.close();

			  }

			if(navigator.userAgent.indexOf("Firefox")!=-1){
			   
				//guardare para firefox.
				
				var fileName = ZFFileName();
				var fileNameToSave = fileName + ".xml";
		
				netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

				var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				var fileXML = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				
				// Ventana de Guardar Como
				var nsIFilePicker = Components.interfaces.nsIFilePicker;
				var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
				fp.init(window, "Guardar Como", nsIFilePicker.modeSave);
 				fp.appendFilter("XML","*.xml");
				fp.defaultString = ZFFileNameLeaf();
				
				var res = fp.show();

				if (res == nsIFilePicker.returnOK){
				  var thefile = fp.file.path;
				}

				thefile+=".xml";
				
				// Si ya existía lo borro.
				file.initWithPath(thefile);
				if(file.exists()){
				  var allow = 'PR_TRUE';
				  file.remove(allow);
				}
				

				fileXML.initWithPath(thefile);
				
				netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

				fileXML.create(0, 0664);
		
					
				var out = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
				out.init(fileXML, 0x20 | 0x02, 00004,null);
	
				out.write(str, str.length);
				out.flush();
				out.close();
				
			}




				}catch(e) {
					alert("No se pudo salvar el documento XML.");
				}
			}	
			else
			{
				alert("Documento No Validado");
				SaveError = true;
				SaveCase = "novalidado";
			}
		}	
		else
		{
			alert("Documento No Validado");
			SaveError = true;
			SaveCase = "novalidado";
		}
		
		try	{
			UserAfterSaveXML(SaveError,SaveCase);
		} 
		catch(e){
			if(bDeb==1) alert('After Save:' + e.description);
		}			

};

function GenerateXmlValues(){
	var xml = '<?xml version="1.0" encoding="UTF-8"?>\n<ZFDGIXMLForm>\n<Id>' + formId + '</Id>\n<Dsc>' + formDescription + '</Dsc>\n<FileDef>'+ formFileDefinition + '</FileDef>\n<Fields>';
	var oObject = $$('[name="thisControl"]');

	for (var i = 0; i < oObject.length; i++)
	{
		var zfexport = oObject[i].readAttribute("zfexport");
		if ( zfexport == "S" )
		{
			obj = oObject[i];
			xml += ZFGenFieldXML(obj);
		}
	}
	xml += "</Fields>\n</ZFDGIXMLForm>";
	return xml;
};
function ZFGenFieldXML(obj){
	var fieldXML = "";
	var val = "";
	if (obj != null)
	{
		var zfid = obj.readAttribute("zfid");
		var zfidext = obj.readAttribute("zfidext");
		var zfextinf = obj.readAttribute("zfextinf");
		
		fieldXML = "<Field>\n<FZFId>" + zfid + "</FZFId>\n<FId>" + zfidext + "</FId>\n<FInfo>" + zfextinf + "</FInfo>\n";
		var control = obj.readAttribute("zfcontrol");
		switch ( control )
					{
						case "C": //Check
							fieldXML += "<FVal>" + obj.checked + "</FVal>\n";
							break;
						case "L": //Combo
							if (obj.selectedIndex >= 0)
								val = obj.options[obj.selectedIndex].value;
							fieldXML += "<FVal>" + val + "</FVal>\n";
							break;
						case "E": //Edit
							var type = obj.readAttribute("zftype");
							if ( (type == 'O') && (obj.innerText != null))
								fieldXML += "<FVal>" + obj.innerText + "</FVal>\n";
							else
								fieldXML += "<FVal>" + obj.value + "</FVal>\n";
							break;
						case "T":
							fieldXML += "<Cols>";
							columnscontrols = "thisControl_" + zfid;
							var oColumns = $$('[name="' + columnscontrols + '"]');
							var zfcolumnid = "" ;
							var row = "";
							for (var j = 0; j < oColumns.length; j++)
							{
								objColumn = oColumns[j];
								colvalue = ZFObjValue(objColumn);
								fieldXML += "<Col>\n";
								zfcolumnid = objColumn.readAttribute("zfid");
								fieldXML += "<ColZFId>" + zfcolumnid + "</ColZFId>\n";
								row = objColumn.readAttribute("row");
								fieldXML += "<ColZFRow>" + row + "</ColZFRow>\n";
								fieldXML += "<ColVal>" + colvalue + "</ColVal>\n";
								fieldXML += "</Col>\n";
							}
							fieldXML += "</Cols>\n";
							break;
						case "M": //Multicheck
							fieldXML += "<Chs>\n";
							checkscontrols = "thisControl_" + zfid;
							var oChecks = $$('[name="' + checkscontrols + '"]');
							var zfvalue = "";
							for (var j = 0; j < oChecks.length; j++)
							{
								objCheck = oChecks[j];
								fieldXML += "<Ch>\n";
								zfvalue = objCheck.readAttribute("zfvalue");
								fieldXML += "<ChZFId>" + zfvalue + "</ChZFId>\n" ;
								fieldXML += "<ChVal>" + objCheck.checked + "</ChVal>\n" ;
								fieldXML += "</Ch>\n";
							}							
							fieldXML += "</Chs>\n";
							break;	
						default:
							fieldXML += "<FVal>" + obj.value + "</FVal>\n";
							break;
					}
	}
	fieldXML += "</Field>\n";
	return fieldXML;
};
function ZFObjValue(obj){
	var objValue = "";
	var control = obj.readAttribute("zfcontrol");
	switch (control)
	{
	case "C": //Check
		objValue = obj.checked ;
		break;
	case "L": //Combo
		objValue = obj.options[obj.selectedIndex].value;
		break;
	case "E": //Edit
		var type = obj.readAttribute("zftype");
		if (type == 'O')
			objValue = obj.innerText;
		else
			objValue = obj.value;
		break;
	}
	return objValue;
};
function ZFGetRowNum(obj){
	row = "0";
	loop = true;
	par = obj;
	while ( loop )
	{
		par = par.parentElement;
		if (par != null)	
		{
			if (par.id == "tablerow" )
			{
				loop = false;
				var zfrow = par.readAttribute("zfrow");
				row = zfrow;
			}
		}		
		else
		{
			loop = false;
		}
	}
	return row;
};

function ZFSaveFile( fileName, str, dialog ){

	if(dialog == null) dialog = false;
	
	var ok = false;
	
	fileName += ".htm" ;
	
	if (dialog == false){ //grabo directo
	
		try{ 
			//var fn = ZFFSPGetCurrentDirectory() +ZFFSOGetFileName(fileName);
			alert('El archivo se guardará en: ' + '\n' + fileName + ' por favor espere ');
			ok  = ZFFSOSaveFile( fileName, str);
			
		} catch(e) {ok == false;}

		if (ok == true){
			ZFAlert( "El formulario se guardó correctamente para su consulta", false);
		} 
		else {
			$('ZFSaved').value = 0;	
			ZFAlert( 'No se pudo salvar el formulario', false);
		}
	} 
	else {  //grabo con dialogo Metodo 2
		//  reduce overhead 
		var w = window.frames.w;
		if( !w )
		{
			w = document.createElement( 'iframe' );
			w.id = 'w';
			w.style.display = 'none';
			document.body.insertBefore(w);
			w = window.frames.w;
			if( !w )
			{
				w = window.open( '', '_temp', 'width=100,height=100' );
				if( !w )
				{
					window.alert( 'No se pudo crear el archivo.' ); 
					return false;
				}
			}
		}
		var d = w.document; 	
		d.open( 'text/html', 'replace' );  
		d.charset = "iso-8859-1";
		d.write(str);
		d.close();

		if( d.execCommand( 'SaveAs', null, fileName ) )
		{  
			window.alert( "El formulario se guardó correctamente para su consulta" );
		} 
		else 
		{   
			$('ZFSaved').value = 0;	
			window.alert( 'No se pudo salvar el formulario' );  
		}  
		w.close();
	}
	return false;  
};

//Auxiliares ZF
function ZFReplaceParms(obj, parameters){
	
	notend = true;
	ini = 0;
	while (notend)
	{
		pos = parameters.indexOf("#",ini);
		if (pos == -1) //si no hay 
			notend = false;
		else
		{	
		//hacer que no sea con espacio chequeando que aparezca espacio o algun caracter tipo + - * ( etc
			buscandocodigo = true;
			j = 0;
			pos2 = pos+1;
			while (buscandocodigo && pos2 < parameters.length )
			{			
				car = parameters.charAt(pos2);
				if (isNaN(car))
					buscandocodigo = false;
				else
					pos2++;	
			}	
			fieldcode = parameters.substring(pos+1,pos2).strip();
			fieldvalue = ZFFieldValue(obj, fieldcode);
			replacestring = "#"+fieldcode;
			parameters = parameters.replace(replacestring, fieldvalue);
		}	
	}		
	return parameters;
};
function ZFFieldValue(obj, fieldcode){
	var fieldvalue = fieldcode;
	var oObject = $("zffieldid" + fieldcode.toString() ); 
	
	if (oObject != null)
	{
		var control = oObject.readAttribute("zfcontrol");
		switch (control)
		{
			case "L": //Combo;
				fieldvalue = oObject.options[oObject.selectedIndex].value;
				break;
			case "E": //Edit
				fieldvalue = oObject.value;
				
				var type = oObject.readAttribute("zftype");
				if (fieldvalue == "" && type == "N")
					fieldvalue = 0;
				if (type == "N" )
					fieldvalue = ZFNumericValue(fieldvalue);
				break;
			case "C": //Check;
				fieldvalue = oObject.checked;
				break;
			//agregar resto de los controles
			default:
				fieldvalue = "";
				break;
		}		
	}				
	return fieldvalue;
};
function ZFNumericValue(numericvalue){
	var numchar = numericvalue.toString();

	//saco puntos de mil
	while (numchar.indexOf(milpoint) > -1 )
		numchar = numchar.replace(milpoint,"");
	
	//si el punto decimal no es "." que es lo que acepta la fun eval de js lo remplazo por .
	if ( decpoint != ".")
	{
		while (numchar.indexOf(decpoint) > -1 )
			numchar = numchar.replace(decpoint,".");
	}	
	return numchar;
};
//Help
function ZFFieldHelp(){
	var control = window.event.srcElement;	
	var textHelp = control.readAttribute("zfhelp");
	
	alert(textHelp);
};
function ZFAyuda(){
	try{UserHelp()} catch(e) {alert("No hay ayuda disponible.");}
};
function ZFOpenURL(url ,properties){
	window.open(url, "_blank", properties);
};
//Mensajes
function ZFMsg(element, msg, msgType){
	if (element != null)
	{
		var type = element.readAttribute("zftype");
		switch(msgType)
		{
			case 'E':
				element.style.backgroundColor= "red";
				if (type == 'N' || type == 'C')
				{
					try{
						element.select();
						element.focus();
					} catch(e) {}
				}
				else
				{
				    if( type == 'F')
				    {
				        try{
				            element.select();
				        } catch (e) {}
				    }
				    
				}
				break;
			case 'W':
				element.style.backgroundColor= "yellow";
				break;
			default:
				element.style.backgroundColor= "";
				break;
		}
	}
	ZFAlert(msg,false);	

};
function ZFMsgForm(element ,msg ){
	ZFAlert(msg,false);
};
//Navegacion
function First(){
	var pagenumber = new Number();
	GoTo(pagenumber);
				
};
function Next(){
	var pagenumber = new Number(currentpage + 1);
	GoTo(pagenumber);
				
};
function Previous(){

	var pagenumber = new Number(currentpage - 1);
	GoTo(pagenumber);
				
};
function Last(){
	var oObject = $$('[name="content"]');
	
	var pagenumber = oObject.length - 1;
	GoTo(pagenumber);
				
};

function GoTo(pagenumber){	
	try	{UserUnLoadPage(currentpage);}catch(e){}
	try	{UserLoadPage(pagenumber);}catch(e){}
	var oObject = $$('[name="content"]');
	
	if (pagenumber >= 0 && pagenumber < oObject.length)
	{
		for (var i= new Number(0) ; i < oObject.length ; i++ )
		{		
			if ( !(pagenumber > i || pagenumber < i ) )
				oObject[i].style.visibility = "visible";
			else
				oObject[i].style.visibility = "hidden";
	
		}
		currentpage = pagenumber;
	}
	var page = "";
	page = pagenumber;
	ZFFocus(page);
	ZFSpanFormulas();
};


function ZFInitCalendar(){
	var intLoop = 0;

	//mes actual
	monthsoptions = $("month").options;
	for (intLoop = 0; intLoop < monthsoptions.length; intLoop++)
	{
		if (intLoop == today.month )
		{
			monthsoptions[intLoop].selected = true;
		}
	}

	//anio actual
	yearsoptions = $("year").options;
	for (intLoop = 0; intLoop < yearsoptions.length; intLoop++)
	{
		if ((intLoop + 1940) == today.year )
		{
			yearsoptions[intLoop].selected = true;
		}
	}
};

function ZFGetDays(month, year){
	// Test for leap year when February is selected.
	if (1 == month)
		return ((0 == year % 4) && (0 != (year % 100))) || (0 == year % 400) ? 29 : 28;
	else
		return daysInMonth[month];
};

function ZFGetToday(){
	// Generate today's date.
	this.now = new Date();
	this.year = this.now.getFullYear() ; // Returned year XXXX
	this.month = this.now.getMonth();
	this.day = this.now.getDate();
};

function ZFSetCalendarDate(d){
	if(d == null) return;
	
	var monthsoptions;
	var intLoop = 0;		
	var m = d.getMonth();
	var y = d.getFullYear();
	
	//mes 	
	monthsoptions = $("month").options;
	for (intLoop = 0; intLoop < monthsoptions.length; intLoop++)
	{		
		if (intLoop == m )
		{
			monthsoptions[intLoop].selected = true;
		} 
		else 
		{
			monthsoptions[intLoop].selected = false;		
		}
	}

	//anio 
	yearsoptions = $("year").options;	
	for (intLoop = 0; intLoop < yearsoptions.length; intLoop++)
	{		
		var parseYear = parseInt(yearsoptions[intLoop].text);
		//if ((intLoop + 1940) == y )
		if (parseYear == y)
		{
			yearsoptions[intLoop].selected = true;
		}
		else
		{
			yearsoptions[intLoop].selected = false;		
		}
	}
//	alert('setcal2=' + $('year').selectedIndex + ','+ $('month').selectedIndex);
}

function ZFNewCalendar(s){

	if(s != null && s != ''){
	    if( s != 'refresh')
	    {
		    var d = ZFStringToDate(s);			
		    ZFSetCalendarDate(d);
		}
	}
	else
	{
	    ZFSetCalendarDate( new Date());
	}
	var yearRef = $('year');	

	var parseYear = parseInt(yearRef[yearRef.selectedIndex].text);
	//alert('year=' + parseYear + ',' +yearRef[yearRef.selectedIndex].text + ','+ $('month').selectedIndex);
	
	var newCal = new Date(parseYear , $('month').selectedIndex, 1);
	var day = -1;
	var startDay = newCal.getDay();
	var daily = 0; 

	today = new ZFGetToday(); // 1st call
	if ((today.year == newCal.getFullYear() ) &&   (today.month == newCal.getMonth()))
	   day = today.day;
	// Cache the calendar table's tBody section, dayList.
//cambio	
	var tableCal = $('tblcal').tBodies.dayList;

	var intDaysInMonth = ZFGetDays(newCal.getMonth(), newCal.getFullYear() );

	for (var intWeek = 0; intWeek < tableCal.rows.length;  intWeek++)
		   for (var intDay = 0;
			 intDay < tableCal.rows[intWeek].cells.length;
			 intDay++)
	 {
		  var cell = tableCal.rows[intWeek].cells[intDay];

		  // Start counting days.
		  if ((intDay == startDay) && (0 == daily))
			 daily = 1;

		  // Highlight the current day.
		  cell.style.color = (day == daily) ? "red" : "";
		  if(day == daily)
		  {
			
			var month = newCal.getMonth()+1;
			if (month < 10)
		    		monthch = "0" + month;
		    	else
		    		monthch = month;	
	
		    	if (day < 10)
		    		daych = "0" + day;	
		    	else	
		    		daych = day;
			
		  }
		  // Output the day number into the cell.
		  if ((daily > 0) && (daily <= intDaysInMonth))
			 cell.innerText = daily++;
		  else
			 cell.innerText = "";
	   }

};
	  
function ZFGetTodayDay(){
	var month = today.month+1;
	if (month < 10)
    		monthch = "0" + month;
    	else
    		monthch = month;	

	var day = today.day;	
    	if (day < 10)
    		daych = "0" + day;	
    	else	
    		daych = day;   

	//document.all[element_id].value = daych + "/" + monthch + "/" + today.year; 
	$(element_id).value = daych + "/" + monthch + "/" + today.year; 
	$('calendar').style.display="none";
    $('iframetop').style.display = "none";		
	$('year').selectedIndex = today.year - 1900;   
	$('month').selectedIndex = today.month; 
};
 
function ZFGetDate(){
	// This code executes when the user clicks on a day
	// in the calendar.
	if ("TD" == event.srcElement.tagName)
    // Test whether day is valid.
    if ("" != event.srcElement.innerText)
	{ 
		var day = event.srcElement.innerText;
		var month = $('month').selectedIndex+1;
		var yearRef = $('year');
    	var year = yearRef[yearRef.selectedIndex].text;
    	if (month < 10)
    		monthch = "0" + month;
    	else
    		monthch = month;	
    	if (day < 10)
    		daych = "0" + day;	
    	else	
    		daych = day;   	
    	
		//document.all[element_id].value= daych + "/" + monthch + "/" +year;
		//document.all.calendar.style.display="none";
		$(element_id).value= daych + "/" + monthch + "/" +year;
		$('calendar').style.display="none";
        $('iframetop').style.display = "none";			
	}
};
 
function ZFGetBodyOffsetX(el_name, shift){
	var x;
	var y;
	x = 0;
	y = 0;

	var elem = $(el_name); //document.all[el_name];
		
	do
	{
		x += elem.offsetLeft;
		y += elem.offsetTop;
		if (elem.tagName == "BODY")
			break;
		elem = elem.offsetParent; 
	} while  (1 > 0);

	shift[0] = x;
	shift[1] = y;
	return  x;
};

function ZFSetCalendarOnElement(el_name){
	if (el_name=="") 
	el_name = element_id;
	var shift = new Array(2);
	ZFGetBodyOffsetX(el_name, shift);
	var cal = $('calendar');
	cal.style.pixelLeft  = shift[0]; //  - document.all.calendar.offsetLeft;
	cal.style.pixelTop = shift[1] + 25 ;

};

function ZFShowCalendar(elem_name){
	if (elem_name=="") elem_name = element_id;
	element_id	= elem_name; 
	
	var e = $(element_id);
	var v = e.value;
	var calendar = $('calendar');
	
	ZFNewCalendar(v);
	ZFSetCalendarOnElement(element_id);
	$('calendar').style.display="inline";
	
    var layer = $('calendar');
    layer.style.display = 'block';
    var iframe = $('iframetop');
    iframe.style.display = 'block';
    iframe.style.width = layer.offsetWidth-2;
    iframe.style.height = layer.offsetHeight-2;
    iframe.style.left = layer.offsetLeft;
    iframe.style.top = layer.offsetTop;			
};

function ZFHideCalendar(){
	//document.all.calendar.style.display="none";
	$('calendar').style.display = "none";
    $('iframetop').style.display = "none";	    
};

function ZFToggleCalendar(elem_name){
	if($('calendar').style.display == "none" || $('calendar').style.display == "")
		ZFShowCalendar(elem_name);
	else
		ZFHideCalendar();
};

function ZFModified(){
	var oObject = $("Validated"); 
//	oObject.checked = false;	
    oObject.setAttribute("checked" , "false");
};

function ZFPrompt(elem){
	var functionName = new Function("fu", "fp","fw","fh","ZFP" + elem.id + "(fu,fp,fw,fh)" ) ;
	var u = elem.readAttribute("PromptCallObj");
	var p = elem.readAttribute("PromptCallParms");
	var w = elem.readAttribute("PromptWidth");
	var h = elem.readAttribute("PromptHeight");
	functionName(u,p,w,h);
};
function ZFFFFix()
{
	//fix labels
	var aObj = $$('[id="leftField"]');
	for (var i = 0; i < aObj.length; i++)
	{
		var obj = aObj[i];
		obj.style.width = '';		
	}	
	//fix date controls
	var aObj = $$('[zftype="F"]');
	for (var i = 0; i < aObj.length; i++)
	{
		var obj = aObj[i];
		obj.style.width = '65%';		
	}	
	
}
